package visl.rasmus.gui;

import java.awt.CheckboxMenuItem;
import java.util.Vector;
/** Enables the use of CheckboxGroups in a menu */
public class CheckboxMenuGroup {
    Vector items;
    int current;
    public CheckboxMenuGroup() {
	items = new Vector();
	current = -1;
    }
    public int getCurrentIndex() { return current; }
    public void setCurrentIndex(int i) { 
	current = i; 
	update();
    }
    public CheckboxMenuItem getCurrent() {
	if (current < 0 || current > items.size()) return null;
	return (CheckboxMenuItem)items.elementAt(current);
    }
    public void setCurrent(CheckboxMenuItem cbmi) {
	if (items.contains(cbmi)) {
	    current = items.indexOf(cbmi);
	}
	update();
    }
    public void add(CheckboxMenuItem cbmi) {
	items.addElement(cbmi);
    }
    private void update() {
	for (int i = 0; i < items.size(); i++) {
	    if (i == current) 
		((CheckboxMenuItem)items.elementAt(i)).setState(true);
	    else
		((CheckboxMenuItem)items.elementAt(i)).setState(false);
	}
    }
    public boolean contains(CheckboxMenuItem cbmi) { 
	return items.contains(cbmi);
    }
    public void clear() {
	items.removeAllElements();
	current = -1;
    }
}
