package visl.rasmus.gui;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Panel;
import java.util.Enumeration;
import java.util.Vector;

public class ImagePanel extends Panel {
    protected ImageCanvas ic;
    protected Vector components;
    public ImagePanel() {
	ic = null;
	components = new Vector();
    }
    public Component add(Component comp) {
	if (ic == null && comp instanceof ImageCanvas) ic = (ImageCanvas)comp;
	else {
	    components.addElement(comp);
	    super.add(comp);
	}
	return comp;
    }
    public Component add(Component comp, int pos) {
	if (ic == null && comp instanceof ImageCanvas) ic = (ImageCanvas)comp;
	else {
	    components.addElement(comp);
	    super.add(comp, pos);
	}
	return comp;
    }
    public Component add(String name, Component comp) {
	if (ic == null && comp instanceof ImageCanvas) ic = (ImageCanvas)comp;
	else {
	    components.addElement(comp);
	    super.add(name, comp);
	}
	return comp;
    }
    public void remove(Component comp) {
	if (ic == comp) ic = null;
	else {
	    components.removeElement(comp);
	    super.remove(comp);
	}
    }
    public void removeAll() {
	components.removeAllElements();
	super.removeAll();
	invalidate();
    }
    public void update(Graphics g) { paint(g); }
    public void paint(Graphics g) {
	Dimension d = size();
	g.setColor(getBackground());
	g.fillRect(0,0, d.width, d.height);
	if (ic != null) ic.updateGraphics(g, null);
	for (Enumeration en = components.elements(); en.hasMoreElements(); ) {
	    Object o = en.nextElement();
	    if (o instanceof Container) 
		((Container)o).paintComponents(g);
	    else if (o instanceof Component)
		((Component)o).paint(g);
	}
    }
    public void resize(Dimension d) {
	if (ic != null) {
	    ic.resize(d);
	}
	super.resize(d);
    }
    public void resize(int w, int h) {
	if (ic != null) {
	    ic.resize(w,h);
	}
	super.resize(w,h);
    }
    public void reshape(int x, int y, int w, int h) {
	if (ic != null) {
	    // Extremely HACKY!!!
	    if (w > 0 && h > 0) {
		ic.resize(w, h);
	    }
	}
	super.reshape(x, y, w, h);
    }
    public Dimension preferredSize() {
	if (ic != null) return ic.preferredSize();
	return getLayout().preferredLayoutSize(this);
    }
    public Dimension minimumSize() {
	return preferredSize();
    }
}
