package visl.rasmus.gui;

import java.awt.Button;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.TextArea;

import visl.resources.Dict;

public class MessageDialog extends Dialog {
    public MessageDialog(Frame parent, String title) {
	super(parent, title, true);
	Panel p = new Panel();
	p.add(new Button(Dict.get(" Ok ")));
	add("South", p);
    }
    public MessageDialog(Frame parent, String title, String message) {
	this(parent, title);
	TextArea ta = new TextArea();
	ta.setText(message);
	ta.setEditable(false);
	add("Center", ta);
	pack();
	show();
    }
    public boolean handleEvent(Event e) {
	if (e.id == Event.WINDOW_DESTROY) {
	    hide();
	} else if (e.target instanceof Button && e.id == Event.ACTION_EVENT) {
	    Button b = (Button)e.target;
	    if (b.getLabel().equals(Dict.get(" Ok "))) {
		hide();
		return true;
	    }
	}
	return false;
    }
}
