package visl.rasmus.handler;

import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Enumeration;
import java.util.Vector;

import visl.rasmus.utils.TimerListener;

/** This class implements a handler to take care of numereous scrolling canvas'
 * @author Rasmus Lock Larsen, VISL Februar 2001. */
public class CanvasScrollHandler
	implements GraphicsHandler, TimerListener, java.awt.image.ImageObserver {
	protected Vector components;
	protected int stepsize;
	protected int x, y;

	public CanvasScrollHandler(int stepsize) {
		components = new Vector();
		this.stepsize = stepsize;
	}
	public synchronized void add(Canvas c) {
		//System.out.println("Added: " + tc);
		components.addElement(c);
		//System.out.println("Add: Number of components: " + components.size());
	}
	public synchronized void remove(Canvas c) {
		components.removeElement(c);
	}
	/** Called by the Timer */
	public synchronized void tick() {
		// Update all the positions
		y += stepsize;
		for (Enumeration en = components.elements(); en.hasMoreElements();) {
			Canvas c = (Canvas) en.nextElement();
			Dimension size = c.size();
			c.reshape(x, y, size.width, size.height);
			System.out.println("x,y = " + x + "," + y);
		}
	}
	/** Comes from the GraphicsHandler */
	public synchronized void updateGraphics(Graphics g, Object arg) {
		//g.setFont((Font)Miscellaneous.get("scrollfont"));
		for (Enumeration en = components.elements(); en.hasMoreElements();) {
			Canvas c = (Canvas) en.nextElement();
			Dimension d = c.size();
			Image im = c.createImage(d.width, d.height);
			c.paint(im.getGraphics());
			g.drawImage(im, x, y, this);
		}
	}
	public boolean imageUpdate(
		Image img,
		int infoflags,
		int x,
		int y,
		int width,
		int height) {
		return false;
	}
}
