package visl.rasmus.hitserver.client;

import java.util.Vector;

/** This class implements the public interface to the HitServer 
 * @see HitXtraClient
 * @author Rasmus Lock Larsen, VISL March 2001 */
public class HitXtraClient extends HitClient {
	public HitXtraClient(
		String servername,
		int port,
		String language,
		String game) {
		super(servername, port, language, game);
	}
	/** Returns the current number of connections to the server */
	public int getNumberOfConnections() {
		int r = -1;
		try {
			connect();
			out.println(GET_NUM_CONNECTIONS);
			r = Integer.parseInt(in.readLine());
			close();
		} catch (Exception e) {
			System.out.println(
				"Exception while trying to get the Number of "
					+ "connections: "
					+ e);
		}
		return r;
	}
	/** Returns the log of the current language */
	public Vector getLog() {
		Vector res = new Vector();
		try {
			connect();
			out.println(GET_LOG + language);
			String line = in.readLine();
			while (!line.equals(EOT)) {
				res.addElement(line);
				line = in.readLine();
			}
			close();
		} catch (Exception x) {
			System.out.println("Exception while trying to retreive log: " + x);
		}
		return res;
	}
	public void sendCommand(String command) {
		try {
			connect();
			out.println(command);
			close();
		} catch (Exception x) {
			System.out.println(
				"Exception while trying to execute command ["
					+ command
					+ "]: "
					+ x);
		}
	}
	public Vector sendQuery(String command) {
		Vector res = new Vector();
		try {
			connect();
			out.println(command);
			String line = in.readLine();
			while (!line.equals(EOT)) {
				res.addElement(line);
				line = in.readLine();
			}
			close();
		} catch (Exception x) {
			System.out.println(
				"Exception while trying to execute command ["
					+ command
					+ "]: "
					+ x);
		}
		return res;
	}
}
