package visl.rasmus.hitserver.data;

/** 
* Visitor interface for the TreeNode.
* Close to the Visitor pattern.
*/
public interface Visitor
{
	/** Whether to execute Command on any of node n's children. */
	public abstract boolean goDeeper(TreeNode n);
	/** Whether to execute Command on any of node n's siblings. */
	public abstract boolean goWider(TreeNode n);
	/** Method to invoke with each node, n. */
	public abstract void execute(TreeNode n);
}
