package visl.wordfall.gui;

import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;

import visl.resources.Dict;

public class CustomDialog extends Dialog {
    protected Panel custompanel;
    protected Button okb, cancelb;
    protected boolean okq;
    protected Label msg;

    public CustomDialog(Frame parent, String[] aforms, String required) {
	super(parent, Dict.get("Choose the word-classes"), true);
	okq = false;

	Panel p = new Panel();
	p.setLayout(new GridLayout(2,1));
	p.add(new Label(Dict.get("Please choose which word-classes to use in the game!"), Label.CENTER));
	p.add(new Label(Dict.get("Note: Highscores are not available for custom-made games!"), Label.CENTER));
	add("North", p);

	custompanel = new Panel();
	custompanel.setLayout(new GridLayout(aforms.length, 1));
	for (int i = 0; i < aforms.length; i++) {
	    Checkbox cb = new Checkbox(aforms[i]+" - "+Dict.get(aforms[i]));
	    if (required.indexOf(":"+aforms[i]+":") != -1) {
		cb.disable();
		cb.setState(true);
	    } else {
		cb.enable();
		cb.setState(false);
	    }
	    custompanel.add(cb);
	}
	add("Center", custompanel);

	p = new Panel();
	okb = new Button(Dict.get("Ok"));
	cancelb = new Button(Dict.get("Cancel"));
	p.add(msg = new Label("          "));
	p.add(okb);
	p.add(cancelb);
	add("South", p);
    }
    public boolean handleEvent(Event e) {
	if (e.id == Event.ACTION_EVENT && e.target instanceof Button) {
	    if (e.target == okb) {
		if (getSelCount() > 1) {
		    okq = true;
		    hide();
		} else {
		    msg.setText("Min. 2 forms");
		    msg.invalidate();
		    validate();
		}
	    } else if (e.target == cancelb) {
		okq = false;
		hide();
	    }
	    return true;
	} else if (e.id == Event.WINDOW_DESTROY) {
	    okq = false;
	    hide();
	    return true;
	}
	return super.handleEvent(e);
    }
    public String getForms() {
	if (!okq) return null;
	StringBuffer res = new StringBuffer(":");
	for (int i = 0; i < custompanel.countComponents(); i++) {
	    Component c = custompanel.getComponent(i);
	    if (c instanceof Checkbox) {
		Checkbox cb = (Checkbox)c;
		if (cb.getState()) {
		    String s = cb.getLabel();
		    res.append(s.substring(0, s.indexOf(" - "))+":");
		    //res.append(cb.getLabel()+":");
		}
	    }
	}
	return res.toString();
    }
    protected int getSelCount() {
	int res = 0;
	for (int i = 0; i < custompanel.countComponents(); i++) {
	    Component c = custompanel.getComponent(i);
	    if (c instanceof Checkbox) {
		Checkbox cb = (Checkbox)c;
		if (cb.getState()) res++;
	    }
	}
	return res;
    }
}
